package com.malk.mc.controller;

import com.alibaba.fastjson.JSONObject;
import com.malk.server.common.McException;
import com.malk.server.common.McR;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Group;
import com.malk.service.dingtalk.DDClient_Report;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Slf4j
@RestController
@RequestMapping("/dd")
public class McDdController {

    @Autowired
    private DDClient_Group ddClientGroup;
    @Autowired
    private DDClient_Report ddClientReport;
    @Autowired
    private DDClient ddClient;

    @PostMapping("/group/createGroupByTemp")
    public McR createGroupByTemp(@RequestBody JSONObject param){
        log.info("创建场景群:{}",param);
        McException.assertParamException_Null(param,"title","template_id","owner_user_id","user_ids");
        String id=ddClientGroup.createGroupByTemp(ddClient.getAccessToken(),param.getString("title"),
                param.getString("template_id"),param.getString("owner_user_id"),param.getString("user_ids"));
        return McR.success(id);
    }

    @PostMapping("/report/create")
    public McR createReport(@RequestBody JSONObject param){
        log.info("创建日志:{}",param);
        McException.assertParamException_Null(param,"template_id","to_chat","dd_from","userid","contents");
        JSONObject contents=param.getJSONObject("contents");
        List list=new ArrayList();
        for(String key:contents.keySet()){
            list.add(contents.getJSONObject(key));
        }
        String result=ddClientReport.createReport(ddClient.getAccessToken(),param.getString("to_userids"),param.getString("to_cids")
                ,param.getString("template_id"),param.getBoolean("to_chat"),param.getString("dd_from"),param.getString("userid"),
                list);
        return McR.success(result);
    }

}
